//+------------------------------------------------------------------
//|                                       PolyFitDetivative by igorad 
//|                               adapted for dynamic zones by mladen
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  PaleVioletRed
#property indicator_color2  DimGray
#property indicator_color3  DeepSkyBlue
#property indicator_color4  DeepSkyBlue
#property indicator_color5  PaleVioletRed
#property indicator_width4  2
#property indicator_style2  STYLE_DOT
#property indicator_style5  STYLE_DOT

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precission );
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precission );
#import

//
//
//
//
//

extern int    Order                  =  1;
extern int    Price                  = PRICE_CLOSE;
extern int    Length                 = 14;
extern int    Degree                 =  1;
extern int    PreSmooth              =  1;
extern int    PreSmoothMode          =  0;
extern int    Signal                 =  5;
extern int    SignalMode             =  3;
extern int    DzLookBackBars         = 35;
extern double DzStartBuyProbability  = 0.05;
extern double DzStartSellProbability = 0.05;

//
//
//
//
//

double PolyFitDerivative[];
double bli[];
double sli[];
double zli[];
double signal[];
double prices[];
double PriceArray[];
int    FitMode = 1;

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,bli);
      SetIndexBuffer(1,zli);
      SetIndexBuffer(2,sli);
      SetIndexBuffer(3,PolyFitDerivative); SetIndexLabel(4,"PolyFit derivative");
      SetIndexBuffer(4,signal);
      SetIndexBuffer(5,prices);
   
   IndicatorShortName("PolyFit derivative ("+Order+","+Price+","+Length+","+Degree+")");
   return(0);
}

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         ArrayResize(PriceArray,Length);

   //
   //
   //
   //
   //
      
   for (i=limit; i>=0; i-- )
   {
      prices[i] = iMA(NULL,0,PreSmooth,0,PreSmoothMode,Price,i);
         ArrayCopy(PriceArray,prices,0,i,Length); 
            PolyFitDerivative[i] = PolyFit(PriceArray,Order,Degree,Length,i*(FitMode-1));
            bli[i]               = dzBuyP (PolyFitDerivative,DzStartBuyProbability,  DzLookBackBars, Bars, i, 0.0001);
            sli[i]               = dzSellP(PolyFitDerivative,DzStartSellProbability, DzLookBackBars, Bars, i, 0.0001);
            zli[i]               = dzBuyP (PolyFitDerivative,0.5,                    DzLookBackBars, Bars, i, 0.0001);
   }
   for (i=limit; i>=0; i-- ) signal[i] = iMAOnArray(PolyFitDerivative,0,Signal,0,SignalMode,i);
   return(0);
}

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

double PolyFit(double price[],int ord, int deg,int len,int bar)
{
double   result=0,Sum=0;
double   AX[13,13],BX[13],CX[13],ZX[13],Pow[26];
int      Row[13];  

   if (len<=1)	Sum=0;
   else
   {	
   
   for (int j=1;j<=deg+1;j++) BX[j]=0;
		
		for (int k=1;k<=len;k++) 
  	   {
  	   double YK=price[len-k];
  	   double XK=k;
  	   double Prod=1;
  	      for (j=1;j<=deg+1;j++)
    	   {
    	   BX[j]+= YK*Prod;
    	   Prod*=XK;
  		   }
      }
      
   for (j=0;j<=2*deg;j++) Pow[j]=0;
	
	Pow[0]=len;
	
      for (k=1;k<=len;k++)
	   {
  	   XK=k;
  	   Prod=k;
  	      for (j=1;j<=2*deg;j++)
  	      {
    	   Pow[j]+= Prod;    	   
    	   Prod*= XK;
  		   }
      }	
	
	   for (j=1;j<=deg+1;j++)
	   {	
         for (int l=1;l<=deg+1;l++) 
  	      AX[j,l]=Pow[j+l-2];
      }	

	for (j=1;j<=deg+1;j++) Row[j]=j;
  	
      for (int i=1;i<=deg;i++)
  	   {
  	      for (k=i+1;k<=deg+1;k++)
         {
            if(MathAbs(AX[Row[k],i]) > MathAbs(AX[Row[i],i]))
      	   {	
      	   int Temp=Row[i];
      	   Row[i]=Row[k];
      	   Row[k]=Temp;
            }
         }

         for (k=i+1;k<=deg+1;k++)
    	   {
    	   if(AX[Row[i],i]!=0) AX[Row[k],i]=AX[Row[k],i]/AX[Row[i],i];
    		   for (l=i+1;l<=deg+1;l++)
      	   AX[Row[k],l]=AX[Row[k],l]-AX[Row[k],i]*AX[Row[i],l];
    		}
		}

   ZX[1]=BX[Row[1]];
      
      for (k=2;k<=deg+1;k++)
  	   {
  	   Sum=0;
      for (l=1;l<=k-1;l++) Sum+=AX[Row[k],l]*ZX[l];
  	   
  	   ZX[k]=BX[Row[k]]-Sum;
	   }
     
	if(AX[Row[deg+1],deg+1] != 0) CX[deg+1]=ZX[deg+1]/AX[Row[deg+1],deg+1];
      	
      for (k=deg;k>=1;k--)
  	   {
  	   Sum=0;
  	   for (l=k+1;l<=deg+1;l++) Sum += AX[Row[k],l]*CX[l]; 
  	   CX[k]=(ZX[k]-Sum)/AX[Row[k],k];
	   }
    
   int mult = 1;
   
   if (ord >= 1)
      for (k = 1; k<=ord; k++) mult *= (deg-k+1); 

	Sum= mult*CX[deg+1];
	
	if(deg > ord) 
	   for (k=deg;k>=ord+1;k--) 
      {
	   int mult1 = 1;
	     if ( ord > 0 )
	     for (i = 1; i<=ord; i++) mult1*=(k-i);
	  
	   Sum = mult1*CX[k]+Sum*(len+bar);
      }         
   }
   return (Sum);
}	